{$IFNDEF opengfx}
{$DEFINE opengfx}
{$I GFX.INC}
{$I BUF2D.INC}
const
  screen:TBuf2d=(x:0;y:0;w:0;h:0;d:nil;method:0); {mapped directly to vram}
  scr:TBuf2d=(x:0;y:0;w:0;h:0;d:nil;method:0);    {screen buffer}

procedure OpenGFX(mode:string12);
begin
  gfx_MODE:=mode;
  svga:=gfx_MODE<>'320x200x8';
  if svga then vbe_Open
  else vga_Open;
  with screen do begin
    init0;
    w:=ScrWidth;
    h:=ScrHeight;
    d:=pointer(vram);
  end;
end;  {OpenGFX}

procedure CloseGFX;
begin
  if svga then vbe_Close
  else vga_Close;
  screen.d:=nil;
  screen.done;
end;  {CloseGFX}

procedure flip;
begin
  screen.pasteInMe(0,0,@scr);
  {this is also possible: scr.pasteMeTo(@screen,0,0);}
end;  {flip}
{$ENDIF}